<template>
  <v-container class="fill-height" fluid>
    <v-row class="fill-height" align="center" justify="center">
      <v-col cols="6">
        <v-card class="elevation-12">
          <v-toolbar dark color="primary">
            <v-toolbar-title>Register form</v-toolbar-title>
          </v-toolbar>
          <v-card-text>
            <v-form>
              <v-alert dense type="error" v-show="showAlert" dismissible>{{
                alertMessage
              }}</v-alert>
              <v-text-field
                v-model="username"
                :counter="10"
                :rules="usernameRules"
                label="Username"
                required
              ></v-text-field>

              <v-text-field
                v-model="password"
                :rules="passwordRules"
                label="Password"
                :error-messages="passwordsMatching"
                @click:append="displayPassword = !displayPassword"
                :append-icon="displayPassword ? 'mdi-eye' : 'mdi-eye-off'"
                :type="displayPassword ? 'text' : 'password'"
                required
              ></v-text-field>

              <v-text-field
                v-model="confirmPassword"
                :rules="passwordRules"
                label="Confirm password"
                :error-messages="passwordsMatching"
                @click:append="displayPassword = !displayConfirmPassword"
                :append-icon="displayPassword ? 'mdi-eye' : 'mdi-eye-off'"
                :type="displayPassword ? 'text' : 'password'"
                required
              ></v-text-field>

              <v-btn
                :disabled="!valid"
                color="success"
                class="mr-4"
                @click="registerUser"
                >Register</v-btn
              >
            </v-form>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <router-link to="login">Already have an account?</router-link>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">
import type { Ref } from "vue";
import { defineComponent, ref, computed } from "vue";
import { useRouter } from "vue-router";

export default defineComponent({
  props: {
    source: String,
  },
  setup(props) {
    const router = useRouter();
    const displayPassword: Ref<boolean> = ref(false);
    const username: Ref<string> = ref("");
    const password: Ref<string> = ref("");
    const confirmPassword: Ref<string> = ref("");
    const valid: Ref<boolean> = ref(false);
    const showAlert: Ref<boolean> = ref(false);
    const alertMessage: Ref<string> = ref("");

    const passwordsMatching = computed(() => {
      if (password.value !== confirmPassword.value) {
        return "Passwords do not match";
      }
    });

    const rules = {
      usernameRules: [
        (v: string) => !!v || "A username is required",
        (v: string) =>
          (v && v.length <= 25) || "Name must be less than 26 characters",
        (v: string) =>
          (v && v.length >= 2) || "Name must be greater 1 character",
      ],
      passwordRules: [
        (v: string) => !!v || "A password is required",
        (v: string) =>
          (v && v.length <= 25) ||
          "The password must be less than 26 characters",
        (v: string) =>
          (v && v.length >= 2) || "The password must be greater 6 characters",
      ],
    };

    async function registerUser() {
      if (valid.value) {
        // const response = await register(username.value, password.value);

        //Cannot receive 409 right now due to the axios error handling
        // if (response.status === 409 && response.title) {
        //   alertMessage.value = response.title;
        //   showAlert.value = true;
        //   return;
        // }

        showAlert.value = false;
        // if (response.username) {
        //   router.push({ name: "Login" });
        // }
      }
    }

    return {
      username,
      password,
      confirmPassword,
      displayPassword,
      valid,
      ...rules,
      registerUser,
      passwordsMatching,
      alertMessage,
      showAlert,
    };
  },
});
</script>

<style></style>
